#include "coffee.h"

int
main(int argc, char * argv[])  {

	stamp* mrcoffee = new stamp;

	if(argc > 1 && argv[1][1] == 'v')  {
		mrcoffee->VERBOSE = NOISY;
		mrcoffee->send(CID_DONT_INC);
	}  else if(argc > 1 && argv[1][1] == 's') {
		mrcoffee->VERBOSE = SIMPLE;
		mrcoffee->send(CID_READ_SENSORS);
	}  else  {
		mrcoffee->VERBOSE = QUIET;
		mrcoffee->send(CID_READ_SENSORS);
	}

	clean_old_procs();
	
	enum_data(mrcoffee);

	delete mrcoffee;

}

void enum_data(stamp const * mrcoffee) {

	if(mrcoffee->VERBOSE == NOISY) {
		cout << "Pot is ";
		if( mrcoffee->raw_data[find_did(DID_POT_IN_PLACE, mrcoffee)][3] ) 
			cout << "NOT in place." << endl;
		else
			cout << "in place." << endl;
		cout << "Filter is ";
		if( mrcoffee->raw_data[find_did(DID_FILTER_IN_PLACE, mrcoffee)][3] )	
			cout << "NOT in place." << endl;
		else
			cout << "in place." << endl;
		cout << "Pot temperature is ";
		

	}  else  if(mrcoffee->VERBOSE == SIMPLE) {
		
		for(int i = 0; i < mrcoffee->packets_read; i++)  {
			for(int j = 0; j < PACKET_DATA_LENGTH + 1; j++)  
				cout << mrcoffee->raw_data[i][j] <<  ' ';
			cout << endl;
		}

	}  else  {

		ofstream output_file;

		output_file.open(RAW_FILENAME, ios::out);

		for(int i = 0; i < mrcoffee->packets_read; i++)  {
			for(int j = 0; j < PACKET_DATA_LENGTH + 1; j++)  
				output_file << mrcoffee->raw_data[i][j] << ' ';
			output_file << endl;
		}

		output_file.close();

	}

}

int clean_old_procs(void) {

	int old_pid;
	ifstream pidfile;

	pidfile.open(PIDFILE, ios::in);
	
	if(pidfile.bad()) {
		create_pid_file();
		return 0;
	}

	pidfile >> old_pid;
	
	kill(old_pid, 9);

	pidfile.close();

	create_pid_file();
	
}


void create_pid_file(void)  {
	int this_pid = getpid();
	ofstream pidfile;

	pidfile.open(PIDFILE, ios::out);
	
	
	pidfile << this_pid;

	pidfile.close();
}

int find_did(int const query, stamp const * mrcoffee)  {
	for(int i = 0; i < mrcoffee->packets_read; i++)
		if(mrcoffee->raw_data[i][0] == query)
			return i;
	return -1;
}
