// Telwrapper.cpp - Outputs Universal codes for Mr. coffee project

#include "comwrapper.h"
#include "telwrapper.h"

int
main(int argc, char * argv[])  {
	int raw_data[TOTAL_FIELDS][PACKET_LENGTH] = { 0 };
	int packets_read = 0;
	
	packets_read = process_file(RAW_FILENAME, raw_data);
	
	if(packets_read <= 0)  {
		cout << "0 0 0 0" << endl;
		cerr << "telwrapper: Unable to read data!" << endl;
		return 1;
	}
	
	output_universal_text(raw_data, packets_read);
	
	return 0;
	
}

void output_universal_text(int const raw_data[TOTAL_FIELDS][PACKET_LENGTH], int const packets_read)  {
	
	for(int i = 0; i < packets_read; i++)  {
		cout << raw_data[i][0] << ' ';
		
		double t;
		
		switch(raw_data[i][0])  {
			case DID_POT_IN_PLACE:
			// drop down to DID_FILTER_IN_PLACE(common handler)
			case DID_FILTER_IN_PLACE:
				cout << raw_data[i][3] << endl;;
				break;
			
			case DID_POTS_BREWED:
			// drop down to DID_TIMES_RUN(common handler)
			case DID_TIMES_RUN:
				cout << raw_data[i][2] * 256 + raw_data[i][3] << endl;
				break;
				
			case DID_POT_TEMP:
				t = raw_data[i][2] * 256 + raw_data[i][3];
				cout.precision(3);
				cout << POT_TEMP_C2 * pow(t, 2) + POT_TEMP_C1 * t + POT_TEMP_C0 << endl;
				cout.precision(0);
				break;
			
			case DID_AIR_TEMP:
				t = raw_data[i][2] * 256 + raw_data[i][3];
				cout.precision(3);
				cout << AIR_TEMP_C2 * pow(t, 2) + AIR_TEMP_C1 * t + AIR_TEMP_C0 << endl;
				break;
				
			case DID_WATER_LEVEL:
				print_water_level(raw_data[i][2] * 256 + raw_data[i][3]);
				cout << endl;
				break;
				

		}
	}	
}
